# Copyright (c) 2002 Nuxeo SARL <http://nuxeo.com>
# Copyright (c) 2002 Prfecture du Bas-Rhin, France
# Copyright (c) 2002 CIRB, Belgique
# Authors: Florent Guillaume <mailto:fg@nuxeo.com>
#          Julien Jalon <mailto:jj@nuxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: __init__.py,v 1.16 2003/05/10 21:37:59 fermigier Exp $


from zLOG import LOG, DEBUG

from AccessControl.PermissionRole import PermissionRole

from Products.CMFCore.CMFCorePermissions import setDefaultRoles
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFDefault.DiscussionItem import DiscussionItemContainer

import PatchDiscussions
import PatchPropertyManager
import CPSRegistration
import CPSSite

# XXX Used by some Products to determine if they have to use
# i18n titles or local titles
isI18N = 1

registerDirectory('skins', globals())
registerDirectory('default_skins', globals())

def initialize(registrar):
    registrar.registerClass(CPSSite.CPSSite,
        constructors=(CPSSite.manage_addCPSSiteForm,
                      CPSSite.manage_addCPSSite,))

# secure module import (see Products/PythonScripts/module_access_example.py)
from AccessControl import allow_module, allow_class, allow_type
from AccessControl import ModuleSecurityInfo, ClassSecurityInfo
from Globals import InitializeClass

# allow_module('base64')
# allow_module('binascii')
# allow_module('crypt')

# Only parts of these modules should be exposed

ModuleSecurityInfo('re').declarePublic('compile', 'findall',
    'match', 'search', 'split', 'sub', 'subn', 'error',
    'I', 'L', 'M', 'S', 'X')
import re
allow_type(type(re.compile('')))
allow_type(type(re.match('x', 'x')))

ModuleSecurityInfo('urllib').declarePublic('urlencode')
ModuleSecurityInfo('zLOG').declarePublic('LOG')

# add getParentNode to simple item
from OFS.SimpleItem import Item
from Acquisition import aq_base, aq_parent, aq_inner

def getParentNode(self):
    """Return parent of the item."""
    return aq_parent(aq_inner(self))

def getItemWithProperty(self, name):
    if hasattr(aq_base(self), 'getProperty'):
        ok = self.getProperty(name)
        if ok:
            return self
    parent = aq_parent(aq_inner(self))
    if parent is not None and hasattr(aq_base(parent), 'getItemWithProperty'):
        return parent.getItemWithProperty(name)

    return None


Item.getParentNode = getParentNode
Item.getItemWithProperty = getItemWithProperty

