##parameters=info

# Get info for all documents in the current context.

here = context.this()

exclude_meta_types = []
exclude_meta_types.append('CPS Member Preferences')



# VHM-compatible slash-begining path of portal or '' if at root
portal_path = context.portal_url(relative=1)
if portal_path:
    portal_path = '/'+portal_path

docinfos = []


# XXX
# CMF bug: contentValues filters objects using the types defined
# in the Types Tool, but does filter using meta_type instead of
# portal_type which breaks a lot of thing.
# So we don't use contentValues and do the filtering by hand.
# XXX still a bug?
#
#items = here.listFolderContents()
#items = here.contentValues()
items = here.objectValues()


for item in items:
    if item.meta_type in exclude_meta_types:
        continue
    d = context.cpsdocument_info_get(item=item)
    docinfos.append(d)


#
# Prepare columns
#

sort_on = info['sort_on']
cols = info['cols']
if sort_on not in cols:
    if 'main' in cols:
        sort_on = 'main'
    else:
        sort_on = ''
    info['sort_on'] = sort_on
sort_order = info['sort_order']
if sort_order not in ('', 'dec'):
    sort_order = ''
    info['sort_order'] = sort_order
tab = info['tab']
colhrefbase = here.absolute_url()
colhrefargsbase = ['tab=%s' % tab]
colhrefs = {}
for col in cols:
    if col == sort_on:
        if sort_order == '':
            so = 'dec'
        else:
            so = ''
    else:
        so = ''
    colhrefargs = list(colhrefargsbase)
    colhrefargs.append('sort_on=%s' % col)
    if so:
        colhrefargs.append('sort_order=%s' % so)
    colhref = colhrefbase +'?' + string.join(colhrefargs, '&')
    colhrefs[col] = colhref

info['colhrefs'] = colhrefs


#
# Sort
#

if not sort_on:
    # default sort
    def thecmp(a, b):
        res = (-cmp(a['isup'], b['isup']) or                  # up-movement first
               -cmp(a['folderish'], b['folderish']) or        # then folders
               cmp(a['moddate'], b['moddate']) or             # then by modification date
               cmp(a['title'].lower(), b['title'].lower()) or # then by title
               0
               )
        return res
else:
    # sort according to given column
    col = info['realcols'][sort_on]
    order = (sort_order == 'dec') and -1 or 1
    def thecmp(a, b, col=col, order=order):
        res = (-cmp(a['isup'], b['isup']) or                  # up-movement first
               -cmp(a['folderish'], b['folderish']) or        # then folders
               order*cmp(a[col], b[col]) or                   # then by chosen column
               cmp(a['moddate'], b['moddate']) or             # then by modification date
               cmp(a['title'].lower(), b['title'].lower()) or # then by title
               0
               )
        return res

docinfos.sort(thecmp)

info['docinfos'] = docinfos


return info
