#
# (C) Copyright 2002 Nuxeo SARL <http://www.nuxeo.com/>
# This product is governed by a license. See LICENSE.txt file.
#

# Python
import sys

# This product
import PortalSubscriptionTool

# CMF
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.CMFCorePermissions import AddPortalContent

contentClasses = ()
contentConstructors = ()
fti = ()

registerDirectory('skins', globals())

this_module = sys.modules[__name__]
tools = (
            PortalSubscriptionTool.PortalSubscriptionTool,
        )
z_tool_bases = utils.initializeBasesPhase1(tools, this_module)

def initialize(registrar):
    #
    # Register defined classes
    #
    utils.ToolInit(
        'Portal Subscription Tool',
        tools=tools,
        product_name='NuxCPSSubscription',
        icon='tool.gif'
    ).initialize(registrar)
      
    utils.ContentInit('Portal Subscription Tool', 
        content_types=contentClasses, 
        permission=AddPortalContent, 
        extra_constructors=contentConstructors, 
        fti=fti
    ).initialize(registrar)

