#!../../bin/python

import sys, unittest, glob, re, types
sys.path.append('../../lib/python')
import Zope

TESTS_SUBDIR = 'tests'

#
# Import all test cases from tests/test_*.py
#
filenames = glob.glob(TESTS_SUBDIR + '/test_*.py')
for filename in filenames:
    m = re.match(TESTS_SUBDIR + '/(test_.*).py', filename)
    module = __import__(TESTS_SUBDIR + '.' + m.group(1), globals(), locals(), 
        ['*'])
    for name in dir(module):
        value = getattr(module, name)
        if type(value) == types.ClassType \
          and issubclass(value, unittest.TestCase):
            globals()[name] = value

#
# Make unittest.main do all the magic
#
print "Running unit tests"
unittest.main(argv=['', '-v'])

