# Copyright (c) 2002 Nuxeo SARL <http://nuxeo.com>
# Copyright (c) 2002 Prfecture du Bas-Rhin, France
# Author: Florent Guillaume <mailto:fg@nuxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: SimpleHierarchy.py,v 1.6 2003/04/06 09:42:38 fermigier Exp $

"""
  SimpleHierarchy
"""

__version__='$Revision: 1.6 $'[11:-2]

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo

from HierarchiesTool import addHierarchyFactory
from BaseHierarchy import BaseHierarchy


class SimpleHierarchy(BaseHierarchy):
    """Simple Hierarchy

    The root is an absolute or relative path (relative to the portal)
    defining the start of the hierarchy tree.
    The root itself can be skipped if it is not relevant.
    """
    meta_type = 'Simple Hierarchy'

    HierarchyLevelType = 'Simple Hierarchy Level'
    criterion = 'Subject'


InitializeClass(SimpleHierarchy)

addHierarchyFactory(SimpleHierarchy)

