##parameters=action=''

object = context.this()
hier = context.portal_hierarchies.main
pubinfo = object.getPublicationWorkflowInfoFor('main')
hierkeydict = hier.getHierarchyKeyDict()

# possible actions:
#  pub, depub: non-"pending" actions, not strictly worfklow
#  accept, reject: workflow-like actions

transs = {
    'accept': ('accept',),
    'reject': ('reject',),
    'depublish': ('depublish',),
    'pubnext': ('accept', 'publish', 'submit'),
    'pubprev': ('reject', 'depublish', 'retract'),
    }
titles = {
    'accept': "_pub_title_accept_",
    'reject': "_pub_title_reject_",
    'depublish': "_pub_title_depublish_",
    'pubnext': "_pub_title_publish_",
    'pubprev': "_pub_title_retract_",
    }

transitions = transs.get(action, ())
# remove unallowed transitions
transitions = filter(lambda x, pi=pubinfo: pi[x], transitions)

title = titles.get(action, '?'+action)

transitiondict = {
    'accept': "_pub_transition_accept_",
    'depublish': "_pub_transition_depublish_",
    'publish': "_pub_transition_publish_",
    'reject': "_pub_transition_reject_",
    'retract': "_pub_transition_retract_",
    'submit': "_pub_transition_submit_",
    }

actiontrans = {
    'accept': "_pub_history_accepted_in_",
    'depublish': "_pub_history_depublished_from_",
    'publish': "_pub_history_published_in_",
    'reject': "_pub_history_rejected_from_",
    'retract': "_pub_history_retracted_from_",
    'submit': "_pub_history_submitted_in_",
    'creation': "_pub_history_created_",
    'refresh': "_pub_history_new_version_",
    }


return {
    'pubinfo': pubinfo,
    'hierkeydict': hierkeydict,
    'title': title,
    'transitions': transitions,
    'transitiondict': transitiondict,
    'actiontrans': actiontrans,
    }
