##parameters=

# This script gets the information about documents we can review
# to be displayed in a box in the homepage

import string

portal_path_length = len(context.portal_url.getPortalPath())
portal_url = context.portal_url(relative=1)
if portal_url: portal_url = '/'+portal_url

catalog = context.portal_catalog
mtool = context.portal_membership
user = mtool.getAuthenticatedMember()
myid = user.getUserName()
try: mygroups = user.getGroups()
except: mygroups = ()
myids = [myid] + ['group:'+id for id in mygroups]


def cmplevels(a, b):
    return cmp(a['order'], b['order'])

def cmpdocs(a, b):
    return cmp(a['title'], b['title'])


hierdict = context.portal_hierarchies.main.getHierarchyDict()

# Get the levels for which we are reviewers
levelbrains = catalog.searchResults(LevelReviewers=myids)

# For each levels get the documents pending there
levellist = []
for levelbrain in levelbrains:
    level = levelbrain.getObject()
    documentbrains = level.queryPendingCatalog()
    doclist = []
    for brain in documentbrains:
        path = brain.getPath()
        rurl = path[portal_path_length:]
        url = portal_url + rurl
        d = {
            'title': brain.Title or brain.id,
            'path': path,
            'url': url,
        }
        doclist.append(d)
    if doclist:
        leveltitle = levelbrain.Title or levelbrain.id
        levelpath = levelbrain.getPath()
        levelorder = hierdict.get(levelpath, {}).get('order', 0)
        doclist.sort(cmpdocs)
        dd = {
            'title': leveltitle,
            'order': levelorder,
            'docs': doclist,
        }
        levellist.append(dd)

levellist.sort(cmplevels)

return levellist
