##parameters=state={}, **kw

# List of document filtered according to criteria

here = context.this()
catalog = context.portal_catalog

# --- get args

searchargs = {}

doctypes = context.cpsdocument_types_get(action='issearchabledocument', allowedhere=0)
okpt = [t['id'] for t in doctypes]
pt = here.types
if pt:
    pt = [t for t in pt if t in okpt]
else:
    pt = okpt
searchargs['portal_type'] = pt

document_state = here.document_state
okrs = ['private', 'pending', 'published']
rs = document_state
if not rs in okrs: rs = okrs
searchargs['review_state'] = rs

oksb = ['ModificationDate', 'Date']
sb = here.sort_by
if not sb in oksb: sb = 'ModificationDate'
searchargs['sort_on'] = sb

sr = here.sort_desc
if sr: searchargs['sort_order'] = 'reverse'

try: maxnum = int(here.max_num)
except: maxnum = 0

if document_state in ('reviewable', 'signable'):
    mtool = context.portal_membership
    user = mtool.getAuthenticatedMember()
    myid = user.getUserName()
    try:
        mygroups = user.getGroups()
    except:
        mygroups = ()
    myids = [myid] + ['group:'+id for id in mygroups]
    if document_state == 'reviewable':
        levelbrains = catalog.searchResults(LevelReviewers=myids)
        pendkeys = [b.levelkey for b in levelbrains]
        if not pendkeys:
            pendkeys = '__dummy_never_found__'
        searchargs['PendingCategories'] = pendkeys
    if document_state == 'signable':
        searchargs['PendingSignatures'] = myids
elif document_state == 'published':
    if here.contextual:
        keys = here.getSubHierarchiesKeys()
        if keys:
            searchargs['PublicCategories'] = keys

# --- do search

res = catalog.searchResults(**searchargs)

docinfos = []
count = 0
for brain in res:
    count = count+1
    if maxnum and count > maxnum:
        break
    #if not brain.PublicCategories:
    #    continue
    d = context.cpsdocument_info_get(brain=brain, modify_brain_url = (rs=='published'))
    docinfos.append(d)

return here.doclistbox_render_body(docinfos=docinfos)
