# Copyright (c) 2002 Prfecture du Bas-Rhin, France
# Copyright (c) 2002 Adelux <http://adequat.c2a.fr>
# Copyright (c) 2002 Nuxeo SARL <http://nuxeo.com>
# Copyright (c) 2002 Florent Guillaume <mailto:fg@nuxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: __init__.py,v 1.6 2002/11/30 16:43:10 fermigier Exp $

from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory

from WorkflowSchemaPermissions import AddWorkflowSchema

import WorkflowSchema
import WorkflowSchemaTool


fti = WorkflowSchema.factory_type_information
tools = (
    WorkflowSchemaTool.WorkflowSchemaTool,
    )

registerDirectory('skins', globals())

def initialize(registrar):
    # TODO: write help
    #registrar.registerHelpTitle('Workflow Schema Help')
    #registrar.registerHelp(directory='help')
    utils.ContentInit(
        'Workflow Schema',
        content_types = (WorkflowSchema.WorkflowSchema,),
        permission = AddWorkflowSchema,
        extra_constructors = (WorkflowSchema.addWorkflowSchema,),
        fti = fti,
        ).initialize(registrar)

    utils.ContentInit(
        'Workflow Schema State',
        content_types = (WorkflowSchema.State,),
        permission = AddWorkflowSchema,
        extra_constructors = (WorkflowSchema.addState,),
        fti = fti,
        ).initialize(registrar)

    utils.ContentInit(
        'Workflow Schema Containers',
        content_types = (WorkflowSchema.EventContainer,
                         WorkflowSchema.ConditionContainer),
        permission = AddWorkflowSchema,
        extra_constructors = (WorkflowSchema.addEventContainer,
                              WorkflowSchema.addConditionContainer),
        fti = fti,
        ).initialize(registrar)

    utils.ContentInit(
        'Workflow Schema Events',
        content_types = (WorkflowSchema.MailEvent,
                         WorkflowSchema.PublicationSwitchEvent),
        permission = AddWorkflowSchema,
        extra_constructors = (WorkflowSchema.addMailEvent,
                              WorkflowSchema.addPublicationSwitchEvent),
        fti = fti,
        ).initialize(registrar)

    utils.ContentInit(
        'Workflow Schema Conditions',
        content_types = (WorkflowSchema.SignatureCondition,
                         WorkflowSchema.SubstateCondition),
        permission = AddWorkflowSchema,
        extra_constructors = (WorkflowSchema.addSignatureCondition,
                              WorkflowSchema.addSubstateCondition),
        fti = fti,
        ).initialize(registrar)

    utils.ToolInit(
        'Workflow Schema Tool',
        tools = tools,
        product_name = 'WorkflowSchema', # for icon and ?...
        icon = 'tool.gif',
        ).initialize(registrar)

